/* Call to render the frame buffer */



#include <string.h>

#include <math.h>

#include "../defs.h"

#include "../mem.h"

#include "../array.h"

#include "../string.h"

#include "../texture.h"

#include "../file.h"

#include "../filerem.h"

#include "../filepcx.h"

#include "../lighttab.h"

#include "../draw/draw.h"

#include "../node.h"

#include "../nodelii.h"

#include "../list.h"

#include "../polygon.h"

#include "../nodeflo.h"

#include "../nodepol.h"

#include "../nodexyz.h"

#include "../nodexy.h"

#include "../map.h"

#include "../math.h"

#include "../mesh.h"

#include "../sector.h"

#include "../nodesec.h"

#include "../refsys.h"

#include "../camsys.h"

#include "../object.h"

#include "../nodeint.h"

#include "../nodetex.h"

#include "../nodeobj.h"

#include "../nodelgt.h"

#include "../filetxe.h"

#include "../eventtab.h"

#include "../scenery.h"

#include "render.h"

#include "../comp/nodecomp.h"

#include "../comp/cokbcont.h"

#include "../comp/codata.h"

#include "../comp/cocamsys.h"

#include "../comp/comesh.h"

   

/* Make the scenery image in frame buffer. Call the sector
and object render functions.
poCamera point the camera object to be used in visualization.
**********************************************************/
void CRender::mRenderFrame ( CNodeObject* poCamera )
{
   // the initial clip edge buffer
   tagInterval
      astClipEdgeBuffer [ MAX_RESY ];
   m_oDraw.mResetClipEdgeBuffer ( astClipEdgeBuffer );

   // the initial clip bounding rectangle
   tagRectangle
      stClipBox;
   stClipBox.nStartX = 0;
   stClipBox.nEndX = m_oDraw.m_nMaxX;
   stClipBox.nStartY = 0;
   stClipBox.nEndY = m_oDraw.m_nMaxY;

   // clear the frame if is the case
   if ( m_poScen->m_nClearBackground != -1 )
      m_oDraw.mClear ( m_poScen->m_nClearBackground );

   // get the reference system
   CCameraSystem
      *poCamSys = &( (CComponentCameraSystem*) poCamera->m_oObject.mRetComponent ( SLOT_REFSYS ) )->m_oCamSys;
      
   // make frame buffer
   mRenderSector ( poCamera->m_oObject.m_poMySec, poCamSys, 0,
                   astClipEdgeBuffer, stClipBox );
}
