/* Render specific sector objects */



#include <string.h>

#include <math.h>

#include "../defs.h"

#include "../mem.h"

#include "../array.h"

#include "../string.h"

#include "../texture.h"

#include "../file.h"

#include "../filerem.h"

#include "../filepcx.h"

#include "../lighttab.h"

#include "../draw/draw.h"

#include "../node.h"

#include "../nodelii.h"

#include "../list.h"

#include "../polygon.h"

#include "../nodeflo.h"

#include "../nodepol.h"

#include "../nodexyz.h"

#include "../nodexy.h"

#include "../map.h"

#include "../math.h"

#include "../mesh.h"

#include "../sector.h"

#include "../nodesec.h"

#include "../refsys.h"

#include "../camsys.h"

#include "../object.h"

#include "../nodeint.h"

#include "../nodetex.h"

#include "../nodeobj.h"

#include "../nodelgt.h"

#include "../filetxe.h"

#include "../eventtab.h"

#include "../scenery.h"

#include "render.h"

#include "../comp/nodecomp.h"

#include "../comp/cokbcont.h"

#include "../comp/codata.h"

#include "../comp/cocamsys.h"

#include "../comp/comesh.h"



/* Render sector objects.
poSector - the sector to render
poCamSys - define the camera to be used in view transformations
yLevel the actual recursion level
pastClipEdgeBuffer have the current clip buffer to be used in poly draw,
stClipBox  the clip square (if all vertexes of the poly are outside, no draw
**********************************************************/
void CRender::mRenderObjects ( CNodeSector *poSector,
                              CCameraSystem *poCamSys, BYTE yLevel,
                              tagInterval* pastClipEdgeBuffer,
                              tagRectangle& stClipBox )
{
   // search for objects to render (objects inside this sector)
   DWORD
      dwNumObjects = poSector->m_oSector.m_oObjects.mRetSize ();

   // for each object in sector
   for ( DWORD dwcO = 0; dwcO < dwNumObjects; dwcO ++ ) {
      
      // the object ID
      DWORD
         dwObjID = poSector->m_oSector.m_oObjects.mRetKey ( dwcO );
      // the object inside this sector
      CNodeObject
         *poObj = (CNodeObject*) poSector->m_oSector.m_oObjects.mRetValue ( dwObjID );

      // get the object body
      CComponentMesh
         *poBody = (CComponentMesh*) poObj->m_oObject.mRetComponent ( SLOT_BODY );

      // verify if it has a body to be rendered
      if ( poBody != NULL ) {

         // define the camera system to be used in this object
         CCameraSystem
            oCamObj;
         // update this camera with the viewer camera, if is not the viewer
         if ( poObj != m_poScen->m_poCamera ) {

            // get the reference system
            CCameraSystem
               *poObjCamSys = &( (CComponentCameraSystem*) poObj->m_oObject.mRetComponent ( SLOT_REFSYS ) )->m_oCamSys;
            // set the camera as the object parameters
            oCamObj.mSetObj ( *poObjCamSys );
            // REVIEW - need this
            oCamObj.m_stPos.fX *= -1;
            oCamObj.m_stPos.fY *= -1;
            oCamObj.m_stPos.fZ *= -1;
            oCamObj.mTransform ( *poCamSys );
         }

         // get the body mesh
         CMesh
           *poMesh = &( (CComponentMesh*) poObj->m_oObject.mRetComponent ( SLOT_BODY ) )->m_oMesh;

         // REVIEW - CONTINUE - NAO NAO TROCADOS OS PARAMETROS????
         mRenderMesh ( *poMesh, poCamSys, &oCamObj,
                       pastClipEdgeBuffer, stClipBox, yLevel );
      }
   }
}
