/* Render one sector */



#include <string.h>

#include <math.h>

#include "../defs.h"

#include "../mem.h"

#include "../array.h"

#include "../string.h"

#include "../texture.h"

#include "../file.h"

#include "../filerem.h"

#include "../filepcx.h"

#include "../lighttab.h"

#include "../draw/draw.h"

#include "../node.h"

#include "../nodelii.h"

#include "../list.h"

#include "../polygon.h"

#include "../nodeflo.h"

#include "../nodepol.h"

#include "../nodexyz.h"

#include "../nodexy.h"

#include "../map.h"

#include "../math.h"

#include "../mesh.h"

#include "../sector.h"

#include "../nodesec.h"

#include "../refsys.h"

#include "../camsys.h"

#include "../object.h"

#include "../nodeint.h"

#include "../nodetex.h"

#include "../nodeobj.h"

#include "../nodelgt.h"

#include "../filetxe.h"

#include "../eventtab.h"

#include "../scenery.h"

#include "render.h"

#include "../comp/nodecomp.h"

#include "../comp/cokbcont.h"

#include "../comp/codata.h"

#include "../comp/cocamsys.h"

#include "../comp/comesh.h"



/* Sector rendering: render sector mesh and call sector objects
rendering.
poSector - the sector to render
poCamSys - define the camera to be used in view transformations
yLevel the actual recursion level
pastClipEdgeBuffer have the current clip buffer to be used in poly draw,
stClipBox  the clip square (if all vertexes of the poly are outside, no draw
**********************************************************/
void CRender::mRenderSector ( CNodeSector *poSector,
                              CCameraSystem *poCamSys, BYTE yLevel,
                              tagInterval* pastClipEdgeBuffer,
                              tagRectangle& stClipBox )
{
   // REVIEW
   // loop bug (normal vector remove error)
   if ( yLevel > 4 )
      return;

   // verify if sector not found
   if ( poSector == NULL )
      ABORT ( MSG_ERROR_SECTOR_NOT_FOUND, __FILE__, __LINE__ )

   CCameraSystem
      oCamObj;

   // current sector mesh
   mRenderMesh ( poSector->m_oSector, &oCamObj, poCamSys,
                 pastClipEdgeBuffer, stClipBox, yLevel );

   // objects
   mRenderObjects ( poSector, poCamSys, yLevel,
                    pastClipEdgeBuffer, stClipBox );
}
